import processing.core.*; 
import processing.xml.*; 

import guicomponents.*; 
import com.codeminders.hidapi.*; 

import com.codeminders.hidapi.*; 

import java.applet.*; 
import java.awt.Dimension; 
import java.awt.Frame; 
import java.awt.event.MouseEvent; 
import java.awt.event.KeyEvent; 
import java.awt.event.FocusEvent; 
import java.awt.Image; 
import java.io.*; 
import java.net.*; 
import java.text.*; 
import java.util.*; 
import java.util.zip.*; 
import java.util.regex.*; 

public class NUScope_2012 extends PApplet {

/*
//  NUScope 2012 App
// Nick Marchuk
// 9/27/2012
//
*/



// NUScope USB
NUScopeCommand ToPic;
int PowerUsage = 0;
int powerBar = 0;
int DCount = 0;
int DFreq = 0;
int[] dataA = new int[800];
int[] dataB = new int[800];
int[] dataD1 = new int[800];
int[] dataD2 = new int[800];
int[] dataD3 = new int[800];
int[] dataD4 = new int[800];
int dataIndex = 0;
int goTo = 0;
int CallAquire = 0;
int frame;
int readyToAsk = 0;
int stopAfterNextFill = 0;
long lastPacketTime = 0;

//// NUScope GUI

PImage wildcat;
PFont font;
Boolean save_image = false;

GOptionGroup opgSweep;
GOption optCont, optSing, optFreeze;

GOptionGroup opgTrigger;
GOption optTriggerOff, optTriggerSensA, optTriggerSensB, optTriggerD1, optTriggerD2, optTriggerD3, optTriggerD4;

GOptionGroup opgTrigEdgeA, opgTrigEdgeB;
GOption optTrigARising, optTrigAFalling, optTrigBRising, optTrigBFalling;

GOptionGroup opgSensA;
GOption optSensA1, optSensA2, optSensA3, optSensA4, optSensA5;

GOptionGroup opgSensB;
GOption optSensB1, optSensB2, optSensB3, optSensB4, optSensB5;

GVertSlider sdrTriggerA, sdrTriggerB, sdrTriggerD1, sdrTriggerD2, sdrTriggerD3, sdrTriggerD4;

GCheckbox cbxD1, cbxD2, cbxD3, cbxD4;

GCheckbox cbxPowerOn;

GOptionGroup opgSampleFreq;
GOption optSF1, optSF2, optSF3, optSF4, optSF5, optSF6, optSF7, optSF8, optSF9, optSF10, optSF11, optSF12, optSF13;

GCombo cboFn, cboFnFreq, cboDig, cboDigFreq;

GButton btnSave, btnPrint, btnExit;

GLabel lblCountFreq;

int ii;

// NUScope data
int i;
int MAXDATALEN = 750;
//int[] dataA = new int[750];
//int[] dataB = new int[750];
//int[] dataD1 = new int[750];
//int[] dataD2 = new int[750];
//int[] dataD3 = new int[750];
//int[] dataD4 = new int[750];
int dataPos;
Boolean sampling = false;

public void setup() {
  size(1100, 650);
  
  sendData = 0;
  frame = 0;

  ToPic = new NUScopeCommand(1, // PowerOn (0-1)
                             0, // SensA (0-7)
                             0, // SensB (0-7)
                             5, // NumDataPoints
                             5333, // SampleRate
                             0, //FnType
                             0, // FnFreq
                             0, // DigType 
                             0, // DigFreq
                             0, // TrigType
                             0 // TrigLevel
                             );

  openPic(0);
  
  // zero the data
  for (i=0;i<MAXDATALEN;i++) {
    dataA[i] = 140;
    dataB[i] = 140;
    dataD1[i] = 0;
    dataD2[i] = 0;
    dataD3[i] = 0;
    dataD4[i] = 0;
  } 
  dataPos = 0;
  
  wildcat = loadImage("wildcat_med.gif");
  font = loadFont("Verdana-BoldItalic-38.vlw");

  G4P.setColorScheme(this, 7); // http://www.lagers.org.uk/g4p/colorscheme.html
  G4P.messagesEnabled(false);

  G4P.setMouseOverEnabled(true);
  G4P.cursor(HAND);

  //// NUScope
  opgSweep = new GOptionGroup();
  optCont = new GOption(this, "Continuous Sweep", 865, 65, 150); //text,x,y,w
  optCont.setFont("Verdana", 10);
  opgSweep.addOption(optCont);
  optSing = new GOption(this, "Single Sweep", 865, 85, 90);
  optSing.setFont("Verdana", 10);
  opgSweep.addOption(optSing);
  optFreeze = new GOption(this, "Freeze", 865, 105, 90);
  optFreeze.setFont("Verdana", 10);
  opgSweep.addOption(optFreeze);		
  opgSweep.setSelected(optCont);

  opgSampleFreq = new GOptionGroup();
  optSF1 = new GOption(this, "1 s/div", 865, 135, 100); //text,x,y,w
  optCont.setFont("Verdana", 10);
  opgSampleFreq.addOption(optSF1);
  optSF2 = new GOption(this, "500 ms/div", 865, 155, 100); //text,x,y,w
  optCont.setFont("Verdana", 10);
  opgSampleFreq.addOption(optSF2);
  optSF3 = new GOption(this, "200 ms/div", 865, 175, 100); //text,x,y,w
  optCont.setFont("Verdana", 10);
  opgSampleFreq.addOption(optSF3);
  optSF4= new GOption(this, "100 ms/div", 865, 195, 100); //text,x,y,w
  optCont.setFont("Verdana", 10);
  opgSampleFreq.addOption(optSF4);
  optSF5 = new GOption(this, "50 ms/div", 865, 215, 100); //text,x,y,w
  optCont.setFont("Verdana", 10);
  opgSampleFreq.addOption(optSF5);
  optSF6 = new GOption(this, "20 ms/div", 865, 235, 100); //text,x,y,w
  optCont.setFont("Verdana", 10);
  opgSampleFreq.addOption(optSF6);
  optSF7 = new GOption(this, "10 ms/div", 865, 255, 100); //text,x,y,w
  optCont.setFont("Verdana", 10);
  opgSampleFreq.addOption(optSF7);
  optSF8 = new GOption(this, "5 ms/div", 865, 275, 100); //text,x,y,w
  optCont.setFont("Verdana", 10);
  opgSampleFreq.addOption(optSF8);
  optSF9 = new GOption(this, "2 ms/div", 865, 295, 100); //text,x,y,w
  optCont.setFont("Verdana", 10);
  opgSampleFreq.addOption(optSF9);
  optSF10 = new GOption(this, "1 ms/div", 865, 315, 100); //text,x,y,w
  optCont.setFont("Verdana", 10);
  opgSampleFreq.addOption(optSF10);
  optSF11 = new GOption(this, "500 us/div", 865, 335, 100); //text,x,y,w
  optCont.setFont("Verdana", 10);
  opgSampleFreq.addOption(optSF11);
  optSF12 = new GOption(this, "200 us/div", 865, 355, 100); //text,x,y,w
  optCont.setFont("Verdana", 10);
  opgSampleFreq.addOption(optSF12);
  optSF13 = new GOption(this, "100 us/div", 865, 375, 100); //text,x,y,w
  optCont.setFont("Verdana", 10);
  opgSampleFreq.addOption(optSF13);
  opgSampleFreq.setSelected(optSF1);

  opgTrigger = new GOptionGroup();
  optTriggerOff = new GOption(this, "Trigger Off", 985, 135, 75); //text,x,y,w
  optTriggerOff.setFont("Verdana", 10);
  opgTrigger.addOption(optTriggerOff);
  optTriggerSensA = new GOption(this, "Trigger A", 985, 155, 75); //text,x,y,w
  optTriggerSensA.setFont("Verdana", 10);
  opgTrigger.addOption(optTriggerSensA);
  optTriggerSensB = new GOption(this, "Trigger B", 985, 175, 75);
  optTriggerSensB.setFont("Verdana", 10);
  opgTrigger.addOption(optTriggerSensB);
  optTriggerD1 = new GOption(this, "Trigger D1", 985, 195, 75);
  optTriggerD1.setFont("Verdana", 10);
  opgTrigger.addOption(optTriggerD1);
  optTriggerD2 = new GOption(this, "Trigger D2", 985, 215, 75);
  optTriggerD2.setFont("Verdana", 10);
  opgTrigger.addOption(optTriggerD2);
  optTriggerD3 = new GOption(this, "Trigger D3", 985, 235, 75);
  optTriggerD3.setFont("Verdana", 10);
  opgTrigger.addOption(optTriggerD3);
  optTriggerD4 = new GOption(this, "Trigger D4", 985, 255, 75);
  optTriggerD4.setFont("Verdana", 10);
  opgTrigger.addOption(optTriggerD4);		
  opgTrigger.setSelected(optTriggerOff);
  
  opgTrigEdgeA = new GOptionGroup();
  optTrigARising = new GOption(this, "Rising Edge", 5, 150, 75); //text,x,y,w
  optTrigARising.setFont("Verdana", 10);
  opgTrigEdgeA.addOption(optTrigARising);
  optTrigAFalling = new GOption(this, "Falling Edge", 5, 170, 75); //text,x,y,w
  optTrigAFalling.setFont("Verdana", 10);
  opgTrigEdgeA.addOption(optTrigAFalling);
  opgTrigEdgeA.setSelected(optTrigARising);
  
  opgTrigEdgeB = new GOptionGroup();
  optTrigBRising = new GOption(this, "Rising Edge", 5, 150+260, 75); //text,x,y,w
  optTrigBRising.setFont("Verdana", 10);
  opgTrigEdgeB.addOption(optTrigBRising);
  optTrigBFalling = new GOption(this, "Falling Edge", 5, 170+260, 75); //text,x,y,w
  optTrigBFalling.setFont("Verdana", 10);
  opgTrigEdgeB.addOption(optTrigBFalling);
  opgTrigEdgeB.setSelected(optTrigBRising);

  opgSensA = new GOptionGroup();
  optSensA1 = new GOption(this, "A Off", 5, 15, 75); //text,x,y,w
  optSensA1.setFont("Verdana", 10);
  opgSensA.addOption(optSensA1);
  optSensA2 = new GOption(this, "1 V/div", 5, 35, 75); //text,x,y,w
  optSensA2.setFont("Verdana", 10);
  opgSensA.addOption(optSensA2);
  optSensA3 = new GOption(this, "500 mV/div", 5, 55, 75); //text,x,y,w
  optSensA3.setFont("Verdana", 10);
  opgSensA.addOption(optSensA3);
  optSensA4 = new GOption(this, "250 mV/div", 5, 75, 75); //text,x,y,w
  optSensA4.setFont("Verdana", 10);
  opgSensA.addOption(optSensA4);
  optSensA5 = new GOption(this, "100 mV/div", 5, 95, 75); //text,x,y,w
  optSensA5.setFont("Verdana", 10);
  opgSensA.addOption(optSensA5);
  opgSensA.setSelected(optSensA2);

  opgSensB = new GOptionGroup();
  optSensB1 = new GOption(this, "B Off", 5, 275, 75); //text,x,y,w
  optSensB1.setFont("Verdana", 10);
  opgSensB.addOption(optSensB1);
  optSensB2 = new GOption(this, "1 V/div", 5, 295, 75); //text,x,y,w
  optSensB2.setFont("Verdana", 10);
  opgSensB.addOption(optSensB2);
  optSensB3 = new GOption(this, "500 mV/div", 5, 315, 75); //text,x,y,w
  optSensB3.setFont("Verdana", 10);
  opgSensB.addOption(optSensB3);
  optSensB4 = new GOption(this, "250 mV/div", 5, 335, 75); //text,x,y,w
  optSensB4.setFont("Verdana", 10);
  opgSensB.addOption(optSensB4);
  optSensB5 = new GOption(this, "100 mV/div", 5, 355, 75); //text,x,y,w
  optSensB5.setFont("Verdana", 10);
  opgSensB.addOption(optSensB5);
  opgSensB.setSelected(optSensB1);

  cbxD1 = new GCheckbox(this, "D1 On", 5, 535, 75); //text,x,y,w
  cbxD1.setSelected(true);
  cbxD1.setFont("Verdana", 10);

  cbxD2 = new GCheckbox(this, "D2 On", 5, 565, 75); //text,x,y,w
  cbxD2.setSelected(false);
  cbxD2.setFont("Verdana", 10);

  cbxD3 = new GCheckbox(this, "D3 On", 5, 595, 75); //text,x,y,w
  cbxD3.setSelected(false);
  cbxD3.setFont("Verdana", 10);

  cbxD4 = new GCheckbox(this, "D4 On", 5, 625, 75); //text,x,y,w
  cbxD4.setSelected(false);
  cbxD4.setFont("Verdana", 10);

  sdrTriggerA = new GVertSlider(this, 90, 5, 10, 255); //x,y,w,h
  sdrTriggerA.setLimits(64, 0, 255); //start,min,max

  sdrTriggerB = new GVertSlider(this, 90, 265, 10, 255); //x,y,w,h
  sdrTriggerB.setLimits(64, 0, 255); //start,min,max

  sdrTriggerD1 = new GVertSlider(this, 90, 530, 10, 25); //x,y,w,h
  sdrTriggerD1.setLimits(5, 5, 20); //start,min,max

  sdrTriggerD2 = new GVertSlider(this, 90, 560, 10, 25); //x,y,w,h
  sdrTriggerD2.setLimits(5, 5, 20); //start,min,max

  sdrTriggerD3 = new GVertSlider(this, 90, 590, 10, 25); //x,y,w,h
  sdrTriggerD3.setLimits(5, 5, 20); //start,min,max

  sdrTriggerD4 = new GVertSlider(this, 90, 620, 10, 25); //x,y,w,h
  sdrTriggerD4.setLimits(5, 5, 20); //start,min,max

  cbxPowerOn = new GCheckbox(this, "Power Supply On", 865, 7, 75); //text,x,y,w
  cbxPowerOn.setSelected(true);
  cbxPowerOn.setFont("Verdana", 10);

  String[] DigFreq = new String[] {
    "1 Hz", "5 Hz", "10 Hz", "50 Hz", "100 Hz"
  };
  cboDigFreq = new GCombo(this, DigFreq, 40, 985, 365, 90); //strings,show max row,x,y,w
  cboDigFreq.setSelected(0); // start at index
  cboDigFreq.setFont("Verdana", 10);
  cboDigFreq.setColorScheme(1);

  String[] Dig = new String[] {
    "Dig Out Low", "Dig Out High", "Square"
  };
  cboDig = new GCombo(this, Dig, 40, 985, 340, 90); //strings,show max row,x,y,w
  cboDig.setSelected(0); // start at index
  cboDig.setFont("Verdana", 10);
  cboDig.setColorScheme(1);

  String[] FnFreq = new String[] {
    "1 Hz", "5 Hz", "10 Hz", "50 Hz", "100 Hz"
  };
  cboFnFreq = new GCombo(this, FnFreq, 40, 985, 310, 90); //strings,show max row,x,y,w
  cboFnFreq.setSelected(0); // start at index
  cboFnFreq.setFont("Verdana", 10);
  cboFnFreq.setColorScheme(1);

  String[] Fn = new String[] {
    "Fn Gen Off", "Sine", "Square", "Triangle"
  };
  cboFn = new GCombo(this, Fn, 40, 985, 285, 90); //strings,show max row,x,y,w
  cboFn.setSelected(0); // start at index
  cboFn.setFont("Verdana", 10);
  cboFn.setColorScheme(1);

  btnSave = new GButton(this, "Save", 855, 620, 60, 20); //text,x,y,w,h
  btnSave.setBorder(1);
  btnSave.setTextAlign(GAlign.LEFT);
  btnSave.setFont("Verdana", 16);

  btnPrint = new GButton(this, "Print", 935, 620, 60, 20); //text,x,y,w,h
  btnPrint.setBorder(1);
  btnPrint.setTextAlign(GAlign.LEFT);
  btnPrint.setFont("Verdana", 16);

  btnExit = new GButton(this, "Exit", 1020, 620, 60, 20); //text,x,y,w,h
  btnExit.setBorder(1);
  btnExit.setTextAlign(GAlign.LEFT);
  btnExit.setFont("Verdana", 16);

  lblCountFreq = new GLabel(this, "Count: 100  Freq: 200Hz", 860, 530, 195, 25 ); //text,x,y,w,h
  lblCountFreq.setBorder(1); // border thickness
  lblCountFreq.setOpaque(true); // background half of border color
  //lblCountFreq.setTextAlign(GAlign.BOTTOM);
  lblCountFreq.setFont("Verdana", 12);

  optTriggerSensB.setVisible(false);
  optTriggerD2.setVisible(false);
  optTriggerD3.setVisible(false);
  optTriggerD4.setVisible(false);
  sdrTriggerA.setVisible(false);
  sdrTriggerB.setVisible(false);
  sdrTriggerD1.setVisible(false);
  sdrTriggerD2.setVisible(false);
  sdrTriggerD3.setVisible(false);
  sdrTriggerD4.setVisible(false);
  optTrigARising.setVisible(false);
  optTrigAFalling.setVisible(false);
  optTrigBRising.setVisible(false);
  optTrigBFalling.setVisible(false);
}

public void draw() {
  if (save_image == true) {
    save("screenshot.png");
    save_image = false;
    println("Saved image!");
  }
  
  background(255);
  rect(100, 5, 750, 255); //x,y,w,h
  rect(100, 265, 750, 255); //x,y,w,h
  rect(100, 5+520+5, 750, 25); //x,y,w,h
  rect(100, 5+520+5+25+5, 750, 25); //x,y,w,h
  rect(100, 5+520+5+25+5+25+5, 750, 25); //x,y,w,h
  rect(100, 5+520+5+25+5+25+5+25+5, 750, 25); //x,y,w,h
  
  for(ii=0;ii<10;ii++) {
    line(100,5+ii*25,850,5+ii*25);
    line(100+ii*75,5,100+ii*75,260);
    
    line(100,265+ii*25,850,265+ii*25);
    line(100+ii*75,265,100+ii*75,520);
    
    line(100+ii*75,530,100+ii*75,555);
    line(100+ii*75,560,100+ii*75,585);
    line(100+ii*75,590,100+ii*75,615);
    line(100+ii*75,620,100+ii*75,645);
  }
  stroke(255);
  rect(105,10,740,245);
  rect(105,270,740,245);
  rect(105,535,740,15);
  rect(105,565,740,15);
  rect(105,595,740,15);
  rect(105,625,740,15);
  stroke(0);
  line(100,5+25*5,850,5+25*5);
  line(100,265+25*5,850,265+25*5);  

  if (optTriggerSensA.isSelected()) {
    stroke(255,0,0);
    line(100, sdrTriggerA.getValue()+5, 850, sdrTriggerA.getValue()+5);
  }
  else if (optTriggerSensB.isSelected()) {
    stroke(255,0,0);
    line(100, sdrTriggerB.getValue()+265, 850, sdrTriggerB.getValue()+265);
  }
  else if (optTriggerD1.isSelected()) {
    stroke(255,0,0);
    line(100, sdrTriggerD1.getValue()+530, 850, sdrTriggerD1.getValue()+530);
  }
  else if (optTriggerD2.isSelected()) {
    stroke(255,0,0);
    line(100, sdrTriggerD2.getValue()+560, 850, sdrTriggerD2.getValue()+560);
  }
  else if (optTriggerD3.isSelected()) {
    stroke(255,0,0);
    line(100, sdrTriggerD3.getValue()+590, 850, sdrTriggerD3.getValue()+590);
  }
  else if (optTriggerD4.isSelected()) {
    stroke(255,0,0);
    line(100, sdrTriggerD4.getValue()+620, 850, sdrTriggerD4.getValue()+620);
  }
  
  // data
  //stroke(255); // no stroke color
  noStroke();
  if (ToPic.PowerOn == 1) {
    fill(66, 3, 149);
  }
  else {
    fill(255,0,0);
  }
  if (optSensA1.isSelected() == false) {
    for (i=0;i<MAXDATALEN;i++) {
      ellipse(100+i,255+5-dataA[i]/4, 3, 3);//x,y,r,r
    }
  }
  if (optSensB1.isSelected() == false) {
    for (i=0;i<MAXDATALEN;i++) {
      ellipse(100+i,255+265-dataB[i]/4, 3, 3);//x,y,r,r
    }
  }
  if (cbxD1.isSelected() == true) {
    for (i=0;i<MAXDATALEN;i++) {
      ellipse(100+i,20+530-dataD1[i]*15, 3, 3);//x,y,r,r
    }
  }
  if (cbxD2.isSelected() == true) {
    for (i=0;i<MAXDATALEN;i++) {
      ellipse(100+i,20+560-dataD2[i]*15, 3, 3);//x,y,r,r
    }
  }
  if (cbxD3.isSelected() == true) {
    for (i=0;i<MAXDATALEN;i++) {
      ellipse(100+i,20+590-dataD3[i]*15, 3, 3);//x,y,r,r
    }
  }
  if (cbxD4.isSelected() == true) {
    for (i=0;i<MAXDATALEN;i++) {
      ellipse(100+i,20+620-dataD4[i]*15, 3, 3);//x,y,r,r
    }
  }
  

  fill(66, 3, 149);
  stroke(0);
  rect(860, 5, 235, 45); // power

  rect(860, 60, 235, 63); // sweep

  rect(860, 130, 112, 262); //ms/div

  rect(980, 130, 115, 142); //trigger

  rect(980, 280, 115, 112); // fn

  rect(3, 5, 90, 115); // SensA

  rect(3, 265, 90, 115); // SensB

  rect(3, 530, 90, 115); // Ds
  
  if (optTriggerSensA.isSelected() == true) {
    rect(3,145,90,45);
  }
  else if (optTriggerSensB.isSelected() == true) {
    rect(3,145+260,90,45);
  }
  
  image(wildcat, 860, 400); //x,y,w,h
  textFont(font);
  text("UScope",942,520);

  // power usage
  fill(128);
  rect(865, 25, 225, 20); //x,y,w,h
  powerBar = PApplet.parseInt(map(PowerUsage,40,175,15,215));
  if (powerBar < 80) {
    fill(255, 0, 0);
  }
  else {
    fill(0,255,0);
  }
  rect(870, 30, powerBar, 10); // max 215
  fill(255);
  
  // sampling
  if (sampling == true) {
    
  }
  else {
    
  }
  
  frame++;
  if ((frame > 2 && readyToAsk == 1 && (optCont.isSelected() == true || optSing.isSelected() == true))||(millis() - lastPacketTime > 5000)) { 
    frame = 0;
    sendData = 1;
    readyToAsk = 0;
    fill(255,0,0);
  }
  else {
    fill(0,255,0);
  }
  ellipse(1050,90,35,35);
  fill(255);
    
} // end draw

public void handleButtonEvents(GButton button) {
  if (button == btnPrint && button.eventType == GButton.CLICKED) {
    println("Print!");
    save_image = true;
  }
  else if (button == btnSave && button.eventType == GButton.CLICKED) {
    //println("Save!");
  }
  else if (button == btnExit && button.eventType == GButton.CLICKED) {
    println("Exit!");
    exit();
  }
}

public void handleComboEvents(GCombo combo) {
  if (combo == cboFn) {
    print("Fn! ");
    print(cboFn.selectedText());
    print(" ");
    println(cboFn.selectedIndex());
  }
}

public void handleCheckboxEvents(GCheckbox cbox) {
  if (cbox == cbxD1) {
    if (cbxD1.isSelected() == true) {
      optTriggerD1.setVisible(true);
    }
    else {
      optTriggerD1.setVisible(false);
      sdrTriggerD1.setVisible(false);
      if (optTriggerD1.isSelected() == true) {
        optTriggerOff.setSelected(true);
      }
      // set the tigger variable off
    }
  }
  else if (cbox == cbxD2) {
    if (cbxD2.isSelected() == true) {
      optTriggerD2.setVisible(true);
    }
    else {
      optTriggerD2.setVisible(false);
      sdrTriggerD2.setVisible(false);
      if (optTriggerD2.isSelected() == true) {
        optTriggerOff.setSelected(true);
      }
      // set the tigger variable off
    }
  }
  else if (cbox == cbxD3) {
    if (cbxD3.isSelected() == true) {
      optTriggerD3.setVisible(true);
    }
    else {
      optTriggerD3.setVisible(false);
      sdrTriggerD3.setVisible(false);
      if (optTriggerD3.isSelected() == true) {
        optTriggerOff.setSelected(true);
      }
      // set the tigger variable off
    }
  }
  else if (cbox == cbxD4) {
    if (cbxD4.isSelected() == true) {
      optTriggerD4.setVisible(true);
    }
    else {
      optTriggerD4.setVisible(false);
      sdrTriggerD4.setVisible(false);
      if (optTriggerD4.isSelected() == true) {
        optTriggerOff.setSelected(true);
      }
      // set the tigger variable off
    }
  }
  else if (cbox == cbxPowerOn) {
    println("Power change");
    if (cbxPowerOn.isSelected() == true) {
      ToPic.PowerOn = 1;
    }
    else {
      ToPic.PowerOn = 0;
    }
  }
}

public void handleOptionEvents(GOption selected, GOption deselected) {
  if (selected == optCont) {
    println("optCont");
    stopAfterNextFill = 0;
  }
  else if (selected == optSing) {
    println("Single");
    stopAfterNextFill = 1;
  }
  else if (selected == optFreeze) {
    println("Freeze");
    stopAfterNextFill = 0;
  }
  else if (selected == optSensA1) {
    ToPic.SensA = 0;
    if (optSensA1.isSelected() == true) {
      optTriggerSensA.setVisible(false);
      sdrTriggerA.setVisible(false);
      optTrigARising.setVisible(false);
      optTrigAFalling.setVisible(false);
      if (optTriggerSensA.isSelected() == true) {
        optTriggerOff.setSelected(true);
      }
      // set the tigger variable off
    }
  }
  else if (selected == optSensA2) {
    ToPic.SensA = 0;
    if (optTriggerSensA.isVisible() == false) {
      optTriggerSensA.setVisible(true);
    }
  }
  else if (selected == optSensA3) {
    ToPic.SensA = 1;
    if (optTriggerSensA.isVisible() == false) {
      optTriggerSensA.setVisible(true);
    }
  }
  else if (selected == optSensA4) {
    ToPic.SensA = 2;
    if (optTriggerSensA.isVisible() == false) {
      optTriggerSensA.setVisible(true);
    }
  }
  else if (selected == optSensA5) {
    ToPic.SensA = 3;
    if (optTriggerSensA.isVisible() == false) {
      optTriggerSensA.setVisible(true);
    }
  }
  else if (selected == optSensB1) {
    ToPic.SensB = 0;
    if (optSensB1.isSelected() == true) {
      sdrTriggerB.setVisible(false);
      optTriggerSensB.setVisible(false);
      optTrigBRising.setVisible(false);
      optTrigBFalling.setVisible(false);
      if (optTriggerSensB.isSelected() == true) {
        optTriggerOff.setSelected(true);
      }
      // set the tigger variable off
    }
  }
  else if (selected == optSensB2) {
    ToPic.SensB = 0;
    if (optTriggerSensB.isVisible() == false) {
      optTriggerSensB.setVisible(true);
    }
  }
  else if (selected == optSensB3) {
    ToPic.SensB = 1;
    if (optTriggerSensB.isVisible() == false) {
      optTriggerSensB.setVisible(true);
    }
  }
  else if (selected == optSensB4) {
    ToPic.SensB = 2;
    if (optTriggerSensB.isVisible() == false) {
      optTriggerSensB.setVisible(true);
    }
  }
  else if (selected == optSensB5) {
    ToPic.SensB = 3;
    if (optTriggerSensB.isVisible() == false) {
      optTriggerSensB.setVisible(true);
    }
  }
  else if (selected == optTriggerD1) {
    if (optTriggerD1.isSelected() == true) {
      sdrTriggerA.setVisible(false);
      sdrTriggerB.setVisible(false);
      sdrTriggerD1.setVisible(true);
      sdrTriggerD2.setVisible(false);
      sdrTriggerD3.setVisible(false);
      sdrTriggerD4.setVisible(false);
      
      optTrigARising.setVisible(false);
      optTrigAFalling.setVisible(false);
      optTrigBRising.setVisible(false);
      optTrigBFalling.setVisible(false);
    }
  }
  else if (selected == optTriggerD2) {
    if (optTriggerD2.isSelected() == true) {
      sdrTriggerA.setVisible(false);
      sdrTriggerB.setVisible(false);
      sdrTriggerD1.setVisible(false);
      sdrTriggerD2.setVisible(true);
      sdrTriggerD3.setVisible(false);
      sdrTriggerD4.setVisible(false);
      
      optTrigARising.setVisible(false);
      optTrigAFalling.setVisible(false);
      optTrigBRising.setVisible(false);
      optTrigBFalling.setVisible(false);
    }
  }
  else if (selected == optTriggerD3) {
    if (optTriggerD3.isSelected() == true) {
      sdrTriggerA.setVisible(false);
      sdrTriggerB.setVisible(false);
      sdrTriggerD1.setVisible(false);
      sdrTriggerD2.setVisible(false);
      sdrTriggerD3.setVisible(true);
      sdrTriggerD4.setVisible(false);
      
      optTrigARising.setVisible(false);
      optTrigAFalling.setVisible(false);
      optTrigBRising.setVisible(false);
      optTrigBFalling.setVisible(false);
    }
  }
  else if (selected == optTriggerD4) {
    if (optTriggerD4.isSelected() == true) {
      sdrTriggerA.setVisible(false);
      sdrTriggerB.setVisible(false);
      sdrTriggerD1.setVisible(false);
      sdrTriggerD2.setVisible(false);
      sdrTriggerD3.setVisible(false);
      sdrTriggerD4.setVisible(true);
      
      optTrigARising.setVisible(false);
      optTrigAFalling.setVisible(false);
      optTrigBRising.setVisible(false);
      optTrigBFalling.setVisible(false);
    }
  }
  else if (selected == optTriggerOff) {
    if (optTriggerOff.isSelected() == true) {
      sdrTriggerA.setVisible(false);
      sdrTriggerB.setVisible(false);
      sdrTriggerD1.setVisible(false);
      sdrTriggerD2.setVisible(false);
      sdrTriggerD3.setVisible(false);
      sdrTriggerD4.setVisible(false);
      
      optTrigARising.setVisible(false);
      optTrigAFalling.setVisible(false);
      optTrigBRising.setVisible(false);
      optTrigBFalling.setVisible(false);
    }
  }
  else if (selected == optTriggerSensA) {
    if (optTriggerSensA.isSelected() == true) {
      sdrTriggerA.setVisible(true);
      sdrTriggerB.setVisible(false);
      sdrTriggerD1.setVisible(false);
      sdrTriggerD2.setVisible(false);
      sdrTriggerD3.setVisible(false);
      sdrTriggerD4.setVisible(false);
      
      optTrigARising.setVisible(true);
      optTrigAFalling.setVisible(true);
      optTrigBRising.setVisible(false);
      optTrigBFalling.setVisible(false);
    }
  }
  else if (selected == optTriggerSensB) {
    if (optTriggerSensB.isSelected() == true) {
      sdrTriggerA.setVisible(false);
      sdrTriggerB.setVisible(true);
      sdrTriggerD1.setVisible(false);
      sdrTriggerD2.setVisible(false);
      sdrTriggerD3.setVisible(false);
      sdrTriggerD4.setVisible(false);
      
      optTrigARising.setVisible(false);
      optTrigAFalling.setVisible(false);
      optTrigBRising.setVisible(true);
      optTrigBFalling.setVisible(true);
    }
  }
  else if (selected == optSF1) {
    ToPic.SampleRate = 5333;
    ToPic.NumDataPoints = 5; // 5 points at 15Hz = 1s/div
    CallAquire = 15; // 
  }
  else if (selected == optSF2) {
    ToPic.SampleRate = 5333; // 10 points at 15Hz = 0.5s/div
    ToPic.NumDataPoints = 10;
    CallAquire = 15; // 
  }
  else if (selected == optSF3) {
    ToPic.SampleRate = 5333; 
    ToPic.NumDataPoints = 25; // 25 points at 15Hz = 0.2s/div
    CallAquire = 15; // 
  }
  else if (selected == optSF4) {
    ToPic.SampleRate = 53333; // want 750 Hz,
    ToPic.NumDataPoints = 50; // .067s to collect
    CallAquire = 15; 
  }
  else if (selected == optSF5) {
    ToPic.SampleRate = 26667; // 1500 Hz
    ToPic.NumDataPoints = 100; // .067s to collect
    CallAquire = 15;
  }
  else if (selected == optSF6) {
    ToPic.SampleRate = 10667; // 3750 Hz
    ToPic.NumDataPoints = 250; // .033s to collect
    CallAquire = 15; 
  }
  else if (selected == optSF7) {
    ToPic.SampleRate = 5333; // 7500 Hz
    ToPic.NumDataPoints = 500; // .0067s to collect
    CallAquire = 15;
  }
  else if (selected == optSF8) {
    ToPic.SampleRate = 2667; // 15000 Hz
    ToPic.NumDataPoints = 750; // .05 s to collect
    CallAquire = 15;
  }
  else if (selected == optSF9) {
    ToPic.SampleRate = 1067; // 37500 Hz
    ToPic.NumDataPoints = 750; // .02s to collect
    CallAquire = 15;
  }
  else if (selected == optSF10) {
    ToPic.SampleRate = 533; // 75000 Hz
    ToPic.NumDataPoints = 750; // .01s to collect
    CallAquire = 15;
  }
  else if (selected == optSF11) {
    ToPic.SampleRate = 267; // 150000 Hz
    ToPic.NumDataPoints = 750; // .005s to collect
    CallAquire = 15;
  }
  else if (selected == optSF12) {
    ToPic.SampleRate = 107; // 375000 Hz
    ToPic.NumDataPoints = 750; // .002s to collect
    CallAquire = 15;
  }
  else if (selected == optSF13) {
    ToPic.SampleRate = 53; // 750000 Hz
    ToPic.NumDataPoints = 750; // 0.001s to collect
    CallAquire = 15; 
  }
}

//////////////////////////////////////////////
// Classes
//////////////////////////////////////////////
class NUScopeCommand {
  int PowerOn;
  int SensA;
  int SensB;
  int NumDataPoints;
  int SampleRate;
  int FnType;
  int FnFreq;
  int DigType;
  int DigFreq;
  int TrigType;
  int TrigLevel;
  //Boolean NewMessage;

  NUScopeCommand(int iPowerOn, int iSensA, int iSensB, int iNumDataPoints, int iSampleRate, int iFnType, int iFnFreq, int iDigType, int iDigFreq, int iTrigType, int iTrigLevel) {
    PowerOn = iPowerOn;
    
    SensA = iSensA;
    SensB = iSensB;
    NumDataPoints = iNumDataPoints;
    SampleRate = iSampleRate;
    FnType = iFnType;
    FnFreq = iFnFreq;
    DigType = iDigType;
    DigFreq = iDigFreq;
    TrigType = iTrigType;
    TrigLevel = iTrigLevel;
    
    //NewMessage = false;
  }
}

public final boolean DEBUG = true;



// HID manager and device
HIDManager mgr;
HIDDeviceInfo[] devs;
HIDDevice pic;
boolean picConnected = false;
String picPath = "";

// openPic takes in the desired productID of the pic you wish to open
public void openPic(int picNo)
{
  ClassPathLibraryLoader.loadNativeHIDLibrary();
  
  // Create instances of HIDManager, and USBListener
  try {
    mgr = HIDManager.getInstance();
  } 
 catch (Exception e) {
    e.printStackTrace();
    if (DEBUG)println("Failed to create HIDManager");
  }
  usbEvent = new USBListener();


  println("Attempting to Connect to PIC #"+picNo+"...");
  while (!picConnected) {
    try {
      // Dump a list of all connected HID devices into devs
      devs = mgr.listDevices();
    } 
    catch (Exception e) {
      e.printStackTrace();
      if (DEBUG)println("Cannot List Devices");
    }

    if (DEBUG)println("Devices:\n");

    // Loop through devices
    for (int i=0;i<devs.length;i++)
    {
      if (DEBUG)
      {
        println(""+i+".\t"+devs[i]);
        println("---------------------------------------------\n");
      }

      // If this is our PIC Microcontroller
      try {
        if (devs[i].getProduct_id() == picNo &&
          devs[i].getVendor_id() == 1240)
        {     
          pic = devs[i].open();
          if (pic!=null) {
            pic.enableBlocking();
            picConnected = true;
            println("Opened "+pic.getProductString());
            readyToAsk = 1;
          }
        }
      } 
      catch (Exception e) {
        e.printStackTrace();
        if (DEBUG)println("Can't open PIC");
      }
    }
  }   

  usbEvent.start();
}

// USB Listener thread
USBListener usbEvent;
byte[] input_buffer = new byte[64];
byte[] output_buffer = new byte[65];
byte[] output_packet = new byte[100];
int[] rxBuffer = new int[8000];
int rxBufferIndex = 0;
int sendData = 0;
int iiusb = 0;
int numInPacket = 0;
int num = 0;
int got13 = 0;
int gotNewData = 0;
int j = 0;

private class USBListener extends Thread 
{
  public void run()
  {
    while (true)
    {
      if (picConnected) {
        try
        {
          int datalen=0;
          int i=0;

          if (sendData==1) {
            output_packet[1] = PApplet.parseByte(0); // start
            output_packet[2] = PApplet.parseByte((ToPic.PowerOn<<6&0x40)|(ToPic.SensA<<3&0x38)|(ToPic.SensB&0x07)); // PowerOn, SensA, SensB
            output_packet[3] = PApplet.parseByte(ToPic.NumDataPoints>>8&0xFF); // NumDataPoints high
            output_packet[4] = PApplet.parseByte(ToPic.NumDataPoints&0xFF); // NumDataPoints low
            output_packet[5] = PApplet.parseByte(ToPic.SampleRate>>8&0xFF); // SampleRate high
            output_packet[6] = PApplet.parseByte(ToPic.SampleRate&0xFF); // SampleRate low
            output_packet[7] = PApplet.parseByte(ToPic.FnType&0xFF); // FnType
            output_packet[8] = PApplet.parseByte(ToPic.FnFreq>>8&0xFF); // FnFreq high
            output_packet[9] = PApplet.parseByte(ToPic.FnFreq&0xFF); // FnFreq low
            output_packet[10] = PApplet.parseByte(ToPic.DigType&0xFF); // DigType
            output_packet[11] = PApplet.parseByte(ToPic.DigFreq>>8&0xFF); // DigFreq high
            output_packet[12] = PApplet.parseByte(ToPic.DigFreq&0xFF); // DigFreq low
            output_packet[13] = PApplet.parseByte(ToPic.TrigType&0xFF); // TrigType
            output_packet[14] = PApplet.parseByte(ToPic.TrigLevel&0xFF); // TrigLevel
            output_packet[15] = PApplet.parseByte(255); // end

            // doesn't matter what you put in index 0
            // index 1 later gets lenght of packet
            numInPacket = 2; 
            output_buffer[numInPacket] = PApplet.parseByte(13); // special character
            //print(int(output_buffer[numInPacket]));
            //print(',');
            numInPacket++;
            output_buffer[numInPacket] = PApplet.parseByte(0); // start
            //print(int(output_buffer[numInPacket]));
            //print(',');
            numInPacket++;
            for (iiusb=2;iiusb<15;iiusb++) {
              if (output_packet[iiusb]==13) {
                output_buffer[numInPacket] = 13;
                //print(int(output_buffer[numInPacket]));
                //print(',');
                numInPacket++;
                output_buffer[numInPacket] = output_packet[iiusb];
                //print(int(output_buffer[numInPacket]));
                //print(',');
                numInPacket++;
              }
              else {
                output_buffer[numInPacket] = output_packet[iiusb];
                //print(int(output_buffer[numInPacket]));
                //print(',');
                numInPacket++;
              }
            }
            output_buffer[numInPacket] = PApplet.parseByte(13); // special character
            //print(int(output_buffer[numInPacket]));
            //print(',');
            numInPacket++;
            output_buffer[numInPacket] = PApplet.parseByte(255); // end
            //print(int(output_buffer[numInPacket]));
            //print(",   ");
            
            output_buffer[1] = PApplet.parseByte(numInPacket);
            output_buffer[0] = PApplet.parseByte(0);
            //println(numInPacket);

            pic.write(output_buffer); // warning - no check to make sure there are less than 64 bytes
            //println("Sent a message");
            sendData = 0;
          }

          pic.read(input_buffer);

          // The number of meaningful bytes is
          // stored in the zeroth byte
          datalen = (int)input_buffer[0]; // includes length          
          if (datalen > 0) {
            //println("Got a message!");
            //print("raw buff = ");
            //for(i=1;i<datalen;i++) {
            //  print(int(input_buffer[i]));
            //  print(" ");
            //}
            //println(" ");
            //got13 = 0;
            for (i=1;i<datalen;i++) {
              if(got13 == 1) {
                if(PApplet.parseInt(input_buffer[i]) == 0) {
                  rxBufferIndex = 0;
                  got13 = 0;
                }
                else if (PApplet.parseInt(input_buffer[i]) == 255) {
                  gotNewData = 1;
                  rxBufferIndex = 0;
                  got13 = 0;
                }
                else if (PApplet.parseInt(input_buffer[i]) == 13) {
                  rxBuffer[rxBufferIndex] = 13;
                  rxBufferIndex++;
                  got13 = 0;
                }
              }
              else if(PApplet.parseInt(input_buffer[i]) == 13) {
                got13 = 1;
              }
              else {
                rxBuffer[rxBufferIndex] = PApplet.parseInt(input_buffer[i]);
                rxBufferIndex++;
                got13 = 0;
              }
            }

            if (gotNewData == 1) {
              gotNewData = 0;
              //print("rx buff = ");
              //for(i=0;i<rxBufferIndex;i++) {
              //  print(rxBuffer[i]);
              //  print(',');
              //}
              //println(" ");
              
              ToPic.PowerOn = rxBuffer[0];
              if(ToPic.PowerOn == 1) {
                cbxPowerOn.setSelected(true);
              }
              else {
                cbxPowerOn.setSelected(false);
              }
              PowerUsage = (rxBuffer[1]<<8)+rxBuffer[2];
              //println(PowerUsage);
              DCount = (rxBuffer[3]<<8)+rxBuffer[4];
              DFreq = (rxBuffer[5]<<8)+rxBuffer[6];
              if (ToPic.NumDataPoints < 750) {
                arrayCopy(dataA,ToPic.NumDataPoints,dataA,0,750-ToPic.NumDataPoints);
                arrayCopy(dataB,ToPic.NumDataPoints,dataB,0,750-ToPic.NumDataPoints);
                arrayCopy(dataD1,ToPic.NumDataPoints,dataD1,0,750-ToPic.NumDataPoints);
                arrayCopy(dataD2,ToPic.NumDataPoints,dataD2,0,750-ToPic.NumDataPoints);
                arrayCopy(dataD3,ToPic.NumDataPoints,dataD3,0,750-ToPic.NumDataPoints);
                arrayCopy(dataD4,ToPic.NumDataPoints,dataD4,0,750-ToPic.NumDataPoints);
                j = 0;
                for(i=750-ToPic.NumDataPoints;i<750;i++) {
                  dataA[i] = rxBuffer[7+j*4]+((rxBuffer[9+j*4]&0x0C)<<6);
                  dataB[i] = rxBuffer[8+j*4]+((rxBuffer[9+j*4]&0x03)<<8);
                  dataD4[i] = ((rxBuffer[10+j*4]&0x02)>>1)^1;
                  dataD3[i] = ((rxBuffer[10+j*4]&0x04)>>2)^1;
                  dataD2[i] = ((rxBuffer[10+j*4]&0x08)>>3)^1;
                  dataD1[i] = ((rxBuffer[10+j*4]&0x10)>>4)^1;
                  j++;
                }
                //dataIndex = 0;
              }
              else {
                for(i=dataIndex;i<ToPic.NumDataPoints+dataIndex;i++) {
                  dataA[i] = rxBuffer[7+i*4]+((rxBuffer[9+i*4]&0x0C)<<6);
                  dataB[i] = rxBuffer[8+i*4]+((rxBuffer[9+i*4]&0x03)<<8);
                  dataD4[i] = ((rxBuffer[10+i*4]&0x02)>>1)^1;
                  dataD3[i] = ((rxBuffer[10+i*4]&0x04)>>2)^1;
                  dataD2[i] = ((rxBuffer[10+i*4]&0x08)>>3)^1;
                  dataD1[i] = ((rxBuffer[10+i*4]&0x10)>>4)^1;
                }
                //dataIndex = dataIndex + ToPic.NumDataPoints;
              }
              //if (dataIndex > 745) {
              //  dataIndex = 0;
              //}
              
              if (stopAfterNextFill == 1) {
                optFreeze.setSelected(true);
                stopAfterNextFill = 0;
              }
              
              readyToAsk = 1;
              lastPacketTime = millis();
              /*
              print("PowerOn = ");
              println(ToPic.PowerOn);
              print("PowerUsage = ");
              println(PowerUsage);
              print("DCount = ");
              println(DCount);
              print("DFreq = ");
              println(DFreq);
              print("A = ");
              for(i=0;i<ToPic.NumDataPoints;i++) {
                print(dataA[i]);
                print(" ");
              }
              println(" ");
              print("B = ");
              for(i=0;i<ToPic.NumDataPoints;i++) {
                print(dataB[i]);
                print(" ");
              }
              println(" ");
              */
              //print("rxBufferIndex = ");
              //println(rxBufferIndex);
              /*
              print("D1 = ");
              for(i=0;i<ToPic.NumDataPoints;i++) {
                print(dataD1[i]);
                print(" ");
              }
              println(" ");
              print("D2 = ");
              for(i=0;i<ToPic.NumDataPoints;i++) {
                print(dataD2[i]);
                print(" ");
              }
              println(" ");
              print("D3 = ");
              for(i=0;i<ToPic.NumDataPoints;i++) {
                print(dataD3[i]);
                print(" ");
              }
              println(" ");
              print("D4 = ");
              for(i=0;i<ToPic.NumDataPoints;i++) {
                print(dataD4[i]);
                print(" ");
              }
              println(" ");
              */
            }
          }
        } 
        catch (Exception e) {
          if (picConnected) e.printStackTrace();
          println("Cannot Read From Device");
        }
      }
    }
  }
}

  static public void main(String args[]) {
    PApplet.main(new String[] { "--bgcolor=#F0F0F0", "NUScope_2012" });
  }
}
